#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>
#include <string.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20100216

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)


#ifndef yyparse
#define yyparse    dvdvmparse
#endif /* yyparse */

#ifndef yylex
#define yylex      dvdvmlex
#endif /* yylex */

#ifndef yyerror
#define yyerror    dvdvmerror
#endif /* yyerror */

#ifndef yychar
#define yychar     dvdvmchar
#endif /* yychar */

#ifndef yyval
#define yyval      dvdvmval
#endif /* yyval */

#ifndef yylval
#define yylval     dvdvmlval
#endif /* yylval */

#ifndef yydebug
#define yydebug    dvdvmdebug
#endif /* yydebug */

#ifndef yynerrs
#define yynerrs    dvdvmnerrs
#endif /* yynerrs */

#ifndef yyerrflag
#define yyerrflag  dvdvmerrflag
#endif /* yyerrflag */

#ifndef yylhs
#define yylhs      dvdvmlhs
#endif /* yylhs */

#ifndef yylen
#define yylen      dvdvmlen
#endif /* yylen */

#ifndef yydefred
#define yydefred   dvdvmdefred
#endif /* yydefred */

#ifndef yydgoto
#define yydgoto    dvdvmdgoto
#endif /* yydgoto */

#ifndef yysindex
#define yysindex   dvdvmsindex
#endif /* yysindex */

#ifndef yyrindex
#define yyrindex   dvdvmrindex
#endif /* yyrindex */

#ifndef yygindex
#define yygindex   dvdvmgindex
#endif /* yygindex */

#ifndef yytable
#define yytable    dvdvmtable
#endif /* yytable */

#ifndef yycheck
#define yycheck    dvdvmcheck
#endif /* yycheck */

#ifndef yyname
#define yyname     dvdvmname
#endif /* yyname */

#ifndef yyrule
#define yyrule     dvdvmrule
#endif /* yyrule */
#define YYPREFIX "dvdvm"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
#ifdef YYPARSE_PARAM_TYPE
#define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
#else
#define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
#endif
#else
#define YYPARSE_DECL() yyparse(void)
#endif /* YYPARSE_PARAM */

extern int YYPARSE_DECL();

#line 2 "dvdvmy.y"

/*
 * Copyright (C) 2002 Scott Smith (trckjunky@users.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#include "compat.h" /* needed for bool */
#include "dvdvm.h"


#define YYERROR_VERBOSE

#line 91 "dvdvmy.y"
typedef union {
    unsigned int int_val;
    char *str_val;
    struct vm_statement *statement;
} YYSTYPE;
#line 147 "dvdvmy.c"
#define NUM_TOK 257
#define G_TOK 258
#define S_TOK 259
#define ID_TOK 260
#define ANGLE_TOK 261
#define AUDIO_TOK 262
#define BREAK_TOK 263
#define BUTTON_TOK 264
#define CALL_TOK 265
#define CELL_TOK 266
#define CHAPTER_TOK 267
#define CLOSEBRACE_TOK 268
#define CLOSEPAREN_TOK 269
#define COUNTER_TOK 270
#define ELSE_TOK 271
#define ENTRY_TOK 272
#define EXIT_TOK 273
#define FPC_TOK 274
#define GOTO_TOK 275
#define IF_TOK 276
#define JUMP_TOK 277
#define MENU_TOK 278
#define NEXT_TOK 279
#define OPENBRACE_TOK 280
#define OPENPAREN_TOK 281
#define PGC_TOK 282
#define PREV_TOK 283
#define PROGRAM_TOK 284
#define PTT_TOK 285
#define REGION_TOK 286
#define RESUME_TOK 287
#define RND_TOK 288
#define ROOT_TOK 289
#define SET_TOK 290
#define SUBTITLE_TOK 291
#define TAIL_TOK 292
#define TITLE_TOK 293
#define TITLESET_TOK 294
#define TOP_TOK 295
#define UP_TOK 296
#define VMGM_TOK 297
#define _OR_TOK 298
#define XOR_TOK 299
#define LOR_TOK 300
#define BOR_TOK 301
#define _AND_TOK 302
#define LAND_TOK 303
#define BAND_TOK 304
#define NOT_TOK 305
#define EQ_TOK 306
#define NE_TOK 307
#define GE_TOK 308
#define GT_TOK 309
#define LE_TOK 310
#define LT_TOK 311
#define ADD_TOK 312
#define SUB_TOK 313
#define MUL_TOK 314
#define DIV_TOK 315
#define MOD_TOK 316
#define ADDSET_TOK 317
#define SUBSET_TOK 318
#define MULSET_TOK 319
#define DIVSET_TOK 320
#define MODSET_TOK 321
#define ANDSET_TOK 322
#define ORSET_TOK 323
#define XORSET_TOK 324
#define SEMICOLON_TOK 325
#define COLON_TOK 326
#define ERROR_TOK 327
#define YYERRCODE 256
static const short dvdvmlhs[] = {                        -1,
    0,    1,    1,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,   10,   10,   10,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   12,   12,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,   13,   13,    3,   14,   14,   14,   14,
   14,   14,   14,   15,   15,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,    8,    9,    9,
    9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
   16,   16,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    6,    7,    7,
};
static const short dvdvmlen[] = {                         2,
    1,    1,    2,    1,    1,    2,    2,    3,    2,    2,
    1,    3,    1,    2,    1,    0,    2,    1,    3,    3,
    3,    3,    3,    3,    1,    2,    0,    2,    0,    5,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    2,    0,    6,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    3,    1,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    4,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    2,
    1,    2,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    5,    1,    3,
};
static const short dvdvmdefred[] = {                      0,
   47,   48,    0,   51,   49,    0,   52,    0,    0,    0,
    0,    0,    0,    0,   53,    0,   50,    0,    1,    0,
    5,    4,   11,    0,   13,    0,    0,    9,   10,    0,
   15,    0,   82,    6,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    7,    3,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   14,   25,    0,    0,
    0,    8,   55,    0,    0,    0,    0,    0,   54,   57,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   12,   94,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   17,    0,   26,    0,
    0,    0,    0,    0,   80,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   31,   33,   34,   40,
   37,   43,   39,   35,   41,   38,   32,   36,   42,    0,
    0,   84,   85,   86,   87,   88,   89,   90,   91,   83,
   23,   22,   24,   20,   21,   19,   28,    0,    0,   56,
   69,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   60,   61,   62,   92,    0,
    0,   79,   77,   30,   44,   46,   68,
};
static const short dvdvmdgoto[] = {                      18,
   19,   20,   21,   22,   23,   24,   25,   67,   68,   32,
   61,  101,  159,   69,   70,   27,
};
static const short dvdvmsindex[] = {                    153,
    0,    0, -322,    0,    0, -310,    0, -239, -237, -306,
 -222, -233,  171,  153,    0, -269,    0,    0,    0,  153,
    0,    0,    0, -211,    0,  355, -213,    0,    0, -176,
    0, -258,    0,    0, -216,   32, -251, -230, -173, -223,
 -249, -164, -258, -145,    0,    0,  153,  113,  113,  113,
  113,  113,  113,  113,  113,  113,    0,    0,  -55, -137,
 -143,    0,    0,   32, -135,   32,  331, -224,    0,    0,
 -178, -177, -160, -158, -131, -129, -128, -121, -112, -110,
  -98,  -97,  -90, -143,    0,    0,  113,  159,  178,  197,
  216,  235,  254,  273,  292,  311,    0,  158,    0,  -37,
  -51,   34, -132,  113,    0,  113,  113,  113,  113,  113,
  113,  113,  113,  113,  113,  113,  113,  113,  113,  113,
  113,  153,   32,   32,   32,   32,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -88,
   13,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  -19,  -86,    0,
    0,   53,  354,  354,  354, -140, -140,  349,  349,  349,
  349,  349,  349, -188, -188,    0,    0,    0,    0, -204,
 -204,    0,    0,    0,    0,    0,    0,
};
static const short dvdvmrindex[] = {                      0,
    0,    0,    0,    0,    0,    0,    0, -225,    0,    0,
    0,    0, -256,    0,    0,    0,    0,    0,    0,    2,
    0,    0,    0,    1,    0,  -50,    0,    0,    0,    0,
    0, -254,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -255,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -253,    0,
 -278,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -310,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -269,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -100,  -77,  -57, -148, -120,  -84,    4,   61,
   84,   93,  107, -196, -168,    0,    0,    0,    0, -259,
 -105,    0,    0,    0,    0,    0,    0,
};
static const short dvdvmgindex[] = {                      0,
   37,  -47,    0,    0,    0,    0,    0,  -24,  -59,  232,
  204,  172,    0,    3,    0,    0,
};
#define YYTABLESIZE 679
static const short dvdvmtable[] = {                      86,
   93,    2,   26,   28,  103,   71,  105,   81,   29,   78,
   16,   27,   27,   18,   29,   58,   26,   16,   34,   59,
   33,   16,   26,   88,   89,   90,   91,   92,   93,   94,
   95,   96,   27,   18,   60,   73,   16,   35,   78,  102,
   78,   16,   78,   72,  122,   82,   29,   36,   16,   26,
   44,   74,   16,   75,   30,   45,   46,   31,   79,   47,
   80,   16,  141,  180,  181,  182,  183,   16,   16,   27,
   27,   18,   58,  123,  179,  124,   56,  125,  126,  162,
   57,  163,  164,  165,  166,  167,  168,  169,  170,  171,
  172,  173,  174,  175,  176,  177,  178,  125,  126,   16,
   59,   58,   58,   58,   58,   58,   58,   58,   62,   58,
   58,   58,   58,   58,   58,   58,   58,   83,   76,   99,
   65,   77,   85,  100,   26,  119,  120,  121,   58,   59,
   59,   59,   59,   59,   59,   59,  161,   59,   59,   59,
   59,   59,   59,   59,   59,  104,  127,  128,   63,   65,
   65,   65,   65,   65,   65,   65,   59,   65,   65,   65,
   65,   65,   65,   76,  129,  123,  130,  124,   66,  125,
  126,  117,  118,  119,  120,  121,   65,   63,   63,   63,
   63,   63,   63,   63,   70,   63,   63,   63,   63,   63,
   63,   67,   76,  131,   76,  132,  133,   66,   66,   66,
   66,   97,   66,  134,   63,   66,   66,   66,   66,   66,
   66,   64,  135,   70,  136,   70,   98,   70,   70,  157,
   67,   67,   67,   67,   66,   67,  137,  138,   67,   67,
   67,   67,   67,   67,  139,  158,  184,  185,  186,   81,
   64,   64,   64,   64,   43,   64,   84,   67,   64,   64,
   64,   64,   64,   64,    0,  140,    0,    0,   93,   93,
   93,   93,   93,   93,   93,   93,    0,   64,   93,    2,
   93,    0,   71,   93,    0,   93,   93,   93,    0,    0,
   93,  160,    0,    0,    0,    0,   93,   93,   63,    1,
    2,   93,    4,    5,    0,    7,    0,    0,    0,    0,
    0,   71,  160,   71,    0,   71,   71,    0,    0,    0,
  106,  107,   64,  108,  109,    0,  110,   15,    0,   65,
    0,  187,   17,    0,  117,  118,  119,  120,  121,   72,
    0,  106,  107,    0,  108,  109,   66,  110,    0,  111,
  112,  113,  114,  115,  116,  117,  118,  119,  120,  121,
  106,  107,   73,  108,  109,    0,  110,    0,   72,    0,
   72,   74,   72,   72,  117,  118,  119,  120,  121,   63,
    1,    2,    0,    4,    5,   75,    7,    0,    0,    0,
    0,   73,    0,   73,    0,   73,   73,    0,    0,    0,
   74,    0,   74,   87,   74,   74,    0,    0,   15,    0,
   65,    0,    0,   17,   75,    0,   75,    0,   75,   75,
    1,    2,    3,    4,    5,    6,    7,    8,  151,  152,
    0,    0,    9,    0,    0,   10,    0,   11,   12,   13,
    0,    0,   14,    0,    0,    0,   37,    0,   15,   16,
    0,    0,  153,   17,    0,    0,  154,    0,  155,   38,
  156,    0,   39,   40,   41,    0,  106,  107,    0,  108,
  109,    0,  110,    0,   30,    0,   42,   31,    0,    0,
  117,  118,  119,  120,  121,  106,  107,    0,  108,  109,
    0,  110,    0,  142,    0,    0,    0,    0,    0,  117,
  118,  119,  120,  121,  106,  107,    0,  108,  109,    0,
  110,    0,  143,    0,    0,    0,    0,    0,  117,  118,
  119,  120,  121,  106,  107,    0,  108,  109,    0,  110,
    0,  144,    0,    0,    0,    0,    0,  117,  118,  119,
  120,  121,  106,  107,    0,  108,  109,    0,  110,    0,
  145,    0,    0,    0,    0,    0,  117,  118,  119,  120,
  121,  106,  107,    0,  108,  109,    0,  110,    0,  146,
    0,    0,    0,    0,    0,  117,  118,  119,  120,  121,
  106,  107,    0,  108,  109,    0,  110,    0,  147,    0,
    0,    0,    0,    0,  117,  118,  119,  120,  121,  106,
  107,    0,  108,  109,    0,  110,    0,  148,    0,    0,
    0,    0,    0,  117,  118,  119,  120,  121,  106,  107,
    0,  108,  109,    0,  110,    0,  149,    0,    0,    0,
    0,    0,  117,  118,  119,  120,  121,    0,  106,  107,
    0,  108,  109,    0,  110,  150,  111,  112,  113,  114,
  115,  116,  117,  118,  119,  120,  121,  107,    0,  108,
    0,    0,  110,    0,    0,  109,    0,  110,    0,    0,
  117,  118,  119,  120,  121,  117,  118,  119,  120,  121,
    0,   48,   49,   50,   51,   52,   53,   54,   55,
};
static const short dvdvmcheck[] = {                      47,
    0,    0,    0,  326,   64,  257,   66,  257,  287,  269,
  267,  267,  267,  267,  325,  274,   14,  274,  325,  278,
  258,  278,   20,   48,   49,   50,   51,   52,   53,   54,
   55,   56,  287,  287,  293,  266,  293,  260,  298,   64,
  300,  267,  266,  295,  269,  295,  325,  281,  274,   47,
   14,  282,  278,  284,  294,  325,   20,  297,  282,  271,
  284,  287,   87,  123,  124,  125,  126,  293,  325,  325,
  325,  325,  269,  298,  122,  300,  290,  302,  303,  104,
  257,  106,  107,  108,  109,  110,  111,  112,  113,  114,
  115,  116,  117,  118,  119,  120,  121,  302,  303,  325,
  269,  298,  299,  300,  301,  302,  303,  304,  325,  306,
  307,  308,  309,  310,  311,  312,  313,  282,  292,  257,
  269,  295,  268,  267,  122,  314,  315,  316,  325,  298,
  299,  300,  301,  302,  303,  304,  269,  306,  307,  308,
  309,  310,  311,  312,  313,  281,  325,  325,  269,  298,
  299,  300,  301,  302,  303,  304,  325,  306,  307,  308,
  309,  310,  311,  269,  325,  298,  325,  300,  269,  302,
  303,  312,  313,  314,  315,  316,  325,  298,  299,  300,
  301,  302,  303,  304,  269,  306,  307,  308,  309,  310,
  311,  269,  298,  325,  300,  325,  325,  298,  299,  300,
  301,  257,  303,  325,  325,  306,  307,  308,  309,  310,
  311,  269,  325,  298,  325,  300,  272,  302,  303,  257,
  298,  299,  300,  301,  325,  303,  325,  325,  306,  307,
  308,  309,  310,  311,  325,  287,  325,  257,  325,  290,
  298,  299,  300,  301,   13,  303,   43,  325,  306,  307,
  308,  309,  310,  311,   -1,   84,   -1,   -1,  258,  259,
  260,  261,  262,  263,  264,  265,   -1,  325,  268,  268,
  270,   -1,  269,  273,   -1,  275,  276,  277,   -1,   -1,
  280,  269,   -1,   -1,   -1,   -1,  286,  287,  257,  258,
  259,  291,  261,  262,   -1,  264,   -1,   -1,   -1,   -1,
   -1,  298,  269,  300,   -1,  302,  303,   -1,   -1,   -1,
  298,  299,  281,  301,  302,   -1,  304,  286,   -1,  288,
   -1,  269,  291,   -1,  312,  313,  314,  315,  316,  269,
   -1,  298,  299,   -1,  301,  302,  305,  304,   -1,  306,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  298,  299,  269,  301,  302,   -1,  304,   -1,  298,   -1,
  300,  269,  302,  303,  312,  313,  314,  315,  316,  257,
  258,  259,   -1,  261,  262,  269,  264,   -1,   -1,   -1,
   -1,  298,   -1,  300,   -1,  302,  303,   -1,   -1,   -1,
  298,   -1,  300,  281,  302,  303,   -1,   -1,  286,   -1,
  288,   -1,   -1,  291,  298,   -1,  300,   -1,  302,  303,
  258,  259,  260,  261,  262,  263,  264,  265,  261,  262,
   -1,   -1,  270,   -1,   -1,  273,   -1,  275,  276,  277,
   -1,   -1,  280,   -1,   -1,   -1,  266,   -1,  286,  287,
   -1,   -1,  285,  291,   -1,   -1,  289,   -1,  291,  279,
  293,   -1,  282,  283,  284,   -1,  298,  299,   -1,  301,
  302,   -1,  304,   -1,  294,   -1,  296,  297,   -1,   -1,
  312,  313,  314,  315,  316,  298,  299,   -1,  301,  302,
   -1,  304,   -1,  325,   -1,   -1,   -1,   -1,   -1,  312,
  313,  314,  315,  316,  298,  299,   -1,  301,  302,   -1,
  304,   -1,  325,   -1,   -1,   -1,   -1,   -1,  312,  313,
  314,  315,  316,  298,  299,   -1,  301,  302,   -1,  304,
   -1,  325,   -1,   -1,   -1,   -1,   -1,  312,  313,  314,
  315,  316,  298,  299,   -1,  301,  302,   -1,  304,   -1,
  325,   -1,   -1,   -1,   -1,   -1,  312,  313,  314,  315,
  316,  298,  299,   -1,  301,  302,   -1,  304,   -1,  325,
   -1,   -1,   -1,   -1,   -1,  312,  313,  314,  315,  316,
  298,  299,   -1,  301,  302,   -1,  304,   -1,  325,   -1,
   -1,   -1,   -1,   -1,  312,  313,  314,  315,  316,  298,
  299,   -1,  301,  302,   -1,  304,   -1,  325,   -1,   -1,
   -1,   -1,   -1,  312,  313,  314,  315,  316,  298,  299,
   -1,  301,  302,   -1,  304,   -1,  325,   -1,   -1,   -1,
   -1,   -1,  312,  313,  314,  315,  316,   -1,  298,  299,
   -1,  301,  302,   -1,  304,  325,  306,  307,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  299,   -1,  301,
   -1,   -1,  304,   -1,   -1,  302,   -1,  304,   -1,   -1,
  312,  313,  314,  315,  316,  312,  313,  314,  315,  316,
   -1,  317,  318,  319,  320,  321,  322,  323,  324,
};
#define YYFINAL 18
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 327
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"NUM_TOK","G_TOK","S_TOK",
"ID_TOK","ANGLE_TOK","AUDIO_TOK","BREAK_TOK","BUTTON_TOK","CALL_TOK","CELL_TOK",
"CHAPTER_TOK","CLOSEBRACE_TOK","CLOSEPAREN_TOK","COUNTER_TOK","ELSE_TOK",
"ENTRY_TOK","EXIT_TOK","FPC_TOK","GOTO_TOK","IF_TOK","JUMP_TOK","MENU_TOK",
"NEXT_TOK","OPENBRACE_TOK","OPENPAREN_TOK","PGC_TOK","PREV_TOK","PROGRAM_TOK",
"PTT_TOK","REGION_TOK","RESUME_TOK","RND_TOK","ROOT_TOK","SET_TOK",
"SUBTITLE_TOK","TAIL_TOK","TITLE_TOK","TITLESET_TOK","TOP_TOK","UP_TOK",
"VMGM_TOK","_OR_TOK","XOR_TOK","LOR_TOK","BOR_TOK","_AND_TOK","LAND_TOK",
"BAND_TOK","NOT_TOK","EQ_TOK","NE_TOK","GE_TOK","GT_TOK","LE_TOK","LT_TOK",
"ADD_TOK","SUB_TOK","MUL_TOK","DIV_TOK","MOD_TOK","ADDSET_TOK","SUBSET_TOK",
"MULSET_TOK","DIVSET_TOK","MODSET_TOK","ANDSET_TOK","ORSET_TOK","XORSET_TOK",
"SEMICOLON_TOK","COLON_TOK","ERROR_TOK",
};
static const char *yyrule[] = {
"$accept : finalparse",
"finalparse : statements",
"statements : statement",
"statements : statement statements",
"statement : jumpstatement",
"statement : callstatement",
"statement : EXIT_TOK SEMICOLON_TOK",
"statement : RESUME_TOK SEMICOLON_TOK",
"statement : GOTO_TOK ID_TOK SEMICOLON_TOK",
"statement : ID_TOK COLON_TOK",
"statement : BREAK_TOK SEMICOLON_TOK",
"statement : setstatement",
"statement : OPENBRACE_TOK statements CLOSEBRACE_TOK",
"statement : ifelsestatement",
"jtsl : TITLESET_TOK NUM_TOK",
"jtsl : VMGM_TOK",
"jtsl :",
"jtml : MENU_TOK NUM_TOK",
"jtml : MENU_TOK",
"jtml : MENU_TOK ENTRY_TOK TITLE_TOK",
"jtml : MENU_TOK ENTRY_TOK ROOT_TOK",
"jtml : MENU_TOK ENTRY_TOK SUBTITLE_TOK",
"jtml : MENU_TOK ENTRY_TOK AUDIO_TOK",
"jtml : MENU_TOK ENTRY_TOK ANGLE_TOK",
"jtml : MENU_TOK ENTRY_TOK PTT_TOK",
"jtml : FPC_TOK",
"jtml : TITLE_TOK NUM_TOK",
"jtml :",
"jcl : CHAPTER_TOK NUM_TOK",
"jcl :",
"jumpstatement : JUMP_TOK jtsl jtml jcl SEMICOLON_TOK",
"jumpstatement : JUMP_TOK CELL_TOK NUM_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PROGRAM_TOK NUM_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK CELL_TOK TOP_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK NEXT_TOK CELL_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PREV_TOK CELL_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PROGRAM_TOK TOP_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK NEXT_TOK PROGRAM_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PREV_TOK PROGRAM_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PGC_TOK TOP_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK NEXT_TOK PGC_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PREV_TOK PGC_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK UP_TOK PGC_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PGC_TOK TAIL_TOK SEMICOLON_TOK",
"resumel : RESUME_TOK NUM_TOK",
"resumel :",
"callstatement : CALL_TOK jtsl jtml jcl resumel SEMICOLON_TOK",
"reg : G_TOK",
"reg : S_TOK",
"reg : AUDIO_TOK",
"reg : SUBTITLE_TOK",
"reg : ANGLE_TOK",
"reg : BUTTON_TOK",
"reg : REGION_TOK",
"regornum : reg",
"regornum : NUM_TOK",
"expression : OPENPAREN_TOK expression CLOSEPAREN_TOK",
"expression : regornum",
"expression : expression ADD_TOK expression",
"expression : expression SUB_TOK expression",
"expression : expression MUL_TOK expression",
"expression : expression DIV_TOK expression",
"expression : expression MOD_TOK expression",
"expression : expression BAND_TOK expression",
"expression : expression BOR_TOK expression",
"expression : expression _AND_TOK expression",
"expression : expression _OR_TOK expression",
"expression : expression XOR_TOK expression",
"expression : RND_TOK OPENPAREN_TOK expression CLOSEPAREN_TOK",
"boolexpr : OPENPAREN_TOK boolexpr CLOSEPAREN_TOK",
"boolexpr : expression EQ_TOK expression",
"boolexpr : expression NE_TOK expression",
"boolexpr : expression GE_TOK expression",
"boolexpr : expression GT_TOK expression",
"boolexpr : expression LE_TOK expression",
"boolexpr : expression LT_TOK expression",
"boolexpr : boolexpr LOR_TOK boolexpr",
"boolexpr : boolexpr LAND_TOK boolexpr",
"boolexpr : boolexpr _OR_TOK boolexpr",
"boolexpr : boolexpr _AND_TOK boolexpr",
"boolexpr : NOT_TOK boolexpr",
"regorcounter : reg",
"regorcounter : COUNTER_TOK G_TOK",
"setstatement : regorcounter SET_TOK expression SEMICOLON_TOK",
"setstatement : reg ADDSET_TOK expression SEMICOLON_TOK",
"setstatement : reg SUBSET_TOK expression SEMICOLON_TOK",
"setstatement : reg MULSET_TOK expression SEMICOLON_TOK",
"setstatement : reg DIVSET_TOK expression SEMICOLON_TOK",
"setstatement : reg MODSET_TOK expression SEMICOLON_TOK",
"setstatement : reg ANDSET_TOK expression SEMICOLON_TOK",
"setstatement : reg ORSET_TOK expression SEMICOLON_TOK",
"setstatement : reg XORSET_TOK expression SEMICOLON_TOK",
"ifstatement : IF_TOK OPENPAREN_TOK boolexpr CLOSEPAREN_TOK statement",
"ifelsestatement : ifstatement",
"ifelsestatement : ifstatement ELSE_TOK statement",

};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;

#define YYPURE 0

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static YYSTACKDATA yystack;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = data->s_mark - data->s_base;
    newss = (data->s_base != 0)
          ? (short *)realloc(data->s_base, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base  = newss;
    data->s_mark = newss + i;

    newvs = (data->l_base != 0)
          ? (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 1:
#line 102 "dvdvmy.y"
	{
    dvd_vm_parsed_cmd=yyval.statement;
}
break;
case 2:
#line 107 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[0].statement;
}
break;
case 3:
#line 110 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[-1].statement;
    yyval.statement->next=yystack.l_mark[0].statement;
}
break;
case 4:
#line 116 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[0].statement;
}
break;
case 5:
#line 119 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[0].statement;
}
break;
case 6:
#line 122 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_EXIT;
}
break;
case 7:
#line 126 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=16;
}
break;
case 8:
#line 131 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_GOTO;
    yyval.statement->s1=yystack.l_mark[-1].str_val;
}
break;
case 9:
#line 136 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LABEL;
    yyval.statement->s1=yystack.l_mark[-1].str_val;
}
break;
case 10:
#line 141 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_BREAK;
}
break;
case 11:
#line 145 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[0].statement;
}
break;
case 12:
#line 148 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[-1].statement;
}
break;
case 13:
#line 151 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[0].statement;
}
break;
case 14:
#line 156 "dvdvmy.y"
	{
    yyval.int_val=(yystack.l_mark[0].int_val)+1;
}
break;
case 15:
#line 159 "dvdvmy.y"
	{
    yyval.int_val=1;
}
break;
case 16:
#line 162 "dvdvmy.y"
	{
    yyval.int_val=0;
}
break;
case 17:
#line 167 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val;
}
break;
case 18:
#line 170 "dvdvmy.y"
	{
    yyval.int_val=120; /* default entry*/
}
break;
case 19:
#line 173 "dvdvmy.y"
	{
    yyval.int_val=122;
}
break;
case 20:
#line 176 "dvdvmy.y"
	{
    yyval.int_val=123;
}
break;
case 21:
#line 179 "dvdvmy.y"
	{
    yyval.int_val=124;
}
break;
case 22:
#line 182 "dvdvmy.y"
	{
    yyval.int_val=125;
}
break;
case 23:
#line 185 "dvdvmy.y"
	{
    yyval.int_val=126;
}
break;
case 24:
#line 188 "dvdvmy.y"
	{
    yyval.int_val=127;
}
break;
case 25:
#line 191 "dvdvmy.y"
	{
    yyval.int_val=121;
}
break;
case 26:
#line 194 "dvdvmy.y"
	{
    yyval.int_val=(yystack.l_mark[0].int_val)|128;
}
break;
case 27:
#line 197 "dvdvmy.y"
	{
    yyval.int_val=0;
}
break;
case 28:
#line 202 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val;
}
break;
case 29:
#line 205 "dvdvmy.y"
	{
    yyval.int_val=0;
}
break;
case 30:
#line 210 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_JUMP;
    yyval.statement->i1=yystack.l_mark[-3].int_val;
    yyval.statement->i2=yystack.l_mark[-2].int_val;
    yyval.statement->i3=yystack.l_mark[-1].int_val;
}
break;
case 31:
#line 217 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_JUMP;
    yyval.statement->i3=2*65536+yystack.l_mark[-1].int_val;
}
break;
case 32:
#line 222 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_JUMP;
    yyval.statement->i3=65536+yystack.l_mark[-1].int_val;
}
break;
case 33:
#line 227 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=1;
}
break;
case 34:
#line 232 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=2;
}
break;
case 35:
#line 237 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=3;
}
break;
case 36:
#line 242 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=5;
}
break;
case 37:
#line 247 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=6;
}
break;
case 38:
#line 252 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=7;
}
break;
case 39:
#line 257 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=9;
}
break;
case 40:
#line 262 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=10;
}
break;
case 41:
#line 267 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=11;
}
break;
case 42:
#line 272 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=12;
}
break;
case 43:
#line 277 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=13;
}
break;
case 44:
#line 284 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val;
}
break;
case 45:
#line 287 "dvdvmy.y"
	{
    yyval.int_val=0;
}
break;
case 46:
#line 292 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_CALL;
    yyval.statement->i1=yystack.l_mark[-4].int_val;
    yyval.statement->i2=yystack.l_mark[-3].int_val;
    yyval.statement->i3=yystack.l_mark[-2].int_val;
    yyval.statement->i4=yystack.l_mark[-1].int_val;
}
break;
case 47:
#line 302 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val;
}
break;
case 48:
#line 305 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val+0x80;
}
break;
case 49:
#line 308 "dvdvmy.y"
	{
    yyval.int_val=0x81;
}
break;
case 50:
#line 311 "dvdvmy.y"
	{
    yyval.int_val=0x82;
}
break;
case 51:
#line 314 "dvdvmy.y"
	{
    yyval.int_val=0x83;
}
break;
case 52:
#line 317 "dvdvmy.y"
	{
    yyval.int_val=0x88;
}
break;
case 53:
#line 320 "dvdvmy.y"
	{
    yyval.int_val=0x80+20;
}
break;
case 54:
#line 325 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val-256;
}
break;
case 55:
#line 328 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val;
}
break;
case 56:
#line 333 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[-1].statement;
}
break;
case 57:
#line 336 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_VAL;
    yyval.statement->i1=yystack.l_mark[0].int_val;
}
break;
case 58:
#line 341 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_ADD,yystack.l_mark[0].statement);
}
break;
case 59:
#line 344 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_SUB,yystack.l_mark[0].statement);
}
break;
case 60:
#line 347 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_MUL,yystack.l_mark[0].statement);
}
break;
case 61:
#line 350 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_DIV,yystack.l_mark[0].statement);
}
break;
case 62:
#line 353 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_MOD,yystack.l_mark[0].statement);
}
break;
case 63:
#line 356 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_AND,yystack.l_mark[0].statement);
}
break;
case 64:
#line 359 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_OR, yystack.l_mark[0].statement);
}
break;
case 65:
#line 362 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_AND,yystack.l_mark[0].statement);
}
break;
case 66:
#line 365 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_OR, yystack.l_mark[0].statement);
}
break;
case 67:
#line 368 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_XOR,yystack.l_mark[0].statement);
}
break;
case 68:
#line 371 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_RND;
    yyval.statement->param=yystack.l_mark[-1].statement;
}
break;
case 69:
#line 378 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[-1].statement;
}
break;
case 70:
#line 381 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_EQ,yystack.l_mark[0].statement);
}
break;
case 71:
#line 384 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_NE,yystack.l_mark[0].statement);
}
break;
case 72:
#line 387 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_GTE,yystack.l_mark[0].statement);
}
break;
case 73:
#line 390 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_GT,yystack.l_mark[0].statement);
}
break;
case 74:
#line 393 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_LTE,yystack.l_mark[0].statement);
}
break;
case 75:
#line 396 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_LT,yystack.l_mark[0].statement);
}
break;
case 76:
#line 399 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_LOR,yystack.l_mark[0].statement);
}
break;
case 77:
#line 402 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_LAND,yystack.l_mark[0].statement);
}
break;
case 78:
#line 405 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_LOR,yystack.l_mark[0].statement);
}
break;
case 79:
#line 408 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_LAND,yystack.l_mark[0].statement);
}
break;
case 80:
#line 411 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_NOT;
    yyval.statement->param=yystack.l_mark[0].statement;
}
break;
case 81:
#line 418 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val;
}
break;
case 82:
#line 421 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val+0x20;
}
break;
case 83:
#line 426 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_SET;
    yyval.statement->i1=yystack.l_mark[-3].int_val;
    yyval.statement->param=yystack.l_mark[-1].statement;
}
break;
case 84:
#line 432 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_ADD,yystack.l_mark[-1].statement);
}
break;
case 85:
#line 435 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_SUB,yystack.l_mark[-1].statement);
}
break;
case 86:
#line 438 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_MUL,yystack.l_mark[-1].statement);
}
break;
case 87:
#line 441 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_DIV,yystack.l_mark[-1].statement);
}
break;
case 88:
#line 444 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_MOD,yystack.l_mark[-1].statement);
}
break;
case 89:
#line 447 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_AND,yystack.l_mark[-1].statement);
}
break;
case 90:
#line 450 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_OR,yystack.l_mark[-1].statement);
}
break;
case 91:
#line 453 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_XOR,yystack.l_mark[-1].statement);
}
break;
case 92:
#line 458 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_IF;
    yyval.statement->param=yystack.l_mark[-2].statement;
    yystack.l_mark[-2].statement->next=statement_new();
    yystack.l_mark[-2].statement->next->op=VM_IF;
    yystack.l_mark[-2].statement->next->param=yystack.l_mark[0].statement;
}
break;
case 93:
#line 468 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[0].statement;
}
break;
case 94:
#line 471 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[-2].statement;
    yyval.statement->param->next->next=yystack.l_mark[0].statement;
}
break;
#line 1446 "dvdvmy.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
